import { EditorModule } from ".";
import { DesignTemp } from "./defines/DesignTemp";
import { ICompKeys } from "./typings";

export const actions = EditorModule.action({
  // 初始化数据
  initData(tempData: DesignTemp) {
    this.store.initDesignData(tempData);
  },
  // 切换模式
  switchMode(v: string) {
    this.store.setMode(v);
  },
  // 添加组件到画布
  addCompToDesign(compKey: ICompKeys) {
    const designComp = this.store.insertDesignContent(compKey);
    this.actions.pickCurrComp(designComp.id);
  },
  // 切换当前组件
  pickCurrComp(compId: string) {
    if (compId === this.store.currCompId) return;
    this.store.setCurrComp(compId);
  },
  // 删除组件
  removeComp(compId: string) {
    if (compId === this.store.currCompId) {
      this.store.currCompId = "";
    }
    this.store.deleteComp(compId);
  },
  // 移动组件
  moveComp(selIndex: number, targetIndex: number) {
    if (selIndex === targetIndex) return;
    this.store.moveComp(selIndex, targetIndex);
  },
});
