import { ModuleRoot } from "queenjs";
import components from "./components";
import config from "./config";
import { store } from "./stores";
import { HistoryCtrl } from "./controllers/HistoryCtrl";
import { initActions } from "./actions/init";
import { editActions } from "./actions/edit";

export class EditorModule extends ModuleRoot {
  config = this.setConfig(config);
  components = this.useComponents(components);
  
  actions = this.createActions([initActions, editActions]);
  store = this.createStore(store);


  historyCtrl = new HistoryCtrl(this);

  onReady() {
    this.historyCtrl.applyActions(Object.keys(editActions));
  }
}

export const { useEditor, initEditor } = EditorModule.hook("Editor");
